org.apache.http.nio

## Interface NHttpServiceHandler

All Known Implementing Classes:
  AsyncNHttpServiceHandler, BufferingHttpServiceHandler, ThrottlingHttpServiceHandler

Deprecated.
(4.2) use `NHttpServerEventHandler`

    @Deprecated
    public interface NHttpServiceHandler

Abstract server-side HTTP protocol handler.

Since:
  4.0

### Method Summary

Methods
`void` `closed(NHttpServerConnection conn)` Deprecated. Triggered when the connection is closed.
`void` `connected(NHttpServerConnection conn)` Deprecated. Triggered when a new incoming connection is created.
`void` `exception(NHttpServerConnection conn, HttpException ex)` Deprecated. Triggered when an HTTP protocol violation occurs while receiving an HTTP request.
`void` `exception(NHttpServerConnection conn, IOException ex)` Deprecated. Triggered when an I/O error occurs while reading from or writing to the underlying channel.
`void` `inputReady(NHttpServerConnection conn, ContentDecoder decoder)` Deprecated. Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.
`void` `outputReady(NHttpServerConnection conn, ContentEncoder encoder)` Deprecated. Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.
`void` `requestReceived(NHttpServerConnection conn)` Deprecated. Triggered when a new HTTP request is received.
`void` `responseReady(NHttpServerConnection conn)` Deprecated. Triggered when the connection is ready to accept a new HTTP response.
`void` `timeout(NHttpServerConnection conn)` Deprecated. Triggered when no input is detected on this connection over the maximum period of inactivity.

### Method Detail

#### connected

    void connected(NHttpServerConnection conn)

Deprecated.
Triggered when a new incoming connection is created.

Parameters:
  `conn` - new incoming connection HTTP connection.

#### requestReceived

    void requestReceived(NHttpServerConnection conn)

Deprecated.
Triggered when a new HTTP request is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP request object.

If the request received encloses a request entity this method will be followed a series of `inputReady(NHttpServerConnection, ContentDecoder)` calls to transfer the request content.

Parameters:
  `conn` - HTTP connection that contains a new HTTP request
See Also:
  `NHttpServerConnection`

#### inputReady

    void inputReady(NHttpServerConnection conn,
                  ContentDecoder decoder)

Deprecated.
Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.

If the content consumer is unable to process the incoming content, input event notifications can be temporarily suspended using `IOControl` interface.

Parameters:
  `conn` - HTTP connection that can produce a new portion of the incoming request content.
  `decoder` - The content decoder to use to read content.
See Also:
  `NHttpServerConnection`, `ContentDecoder`, `IOControl`

#### responseReady

    void responseReady(NHttpServerConnection conn)

Deprecated.
Triggered when the connection is ready to accept a new HTTP response. The protocol handler does not have to submit a response if it is not ready.

Parameters:
  `conn` - HTTP connection that contains an HTTP response
See Also:
  `NHttpServerConnection`

#### outputReady

    void outputReady(NHttpServerConnection conn,
                   ContentEncoder encoder)

Deprecated.
Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.

If the content producer is unable to generate the outgoing content, output event notifications can be temporarily suspended using `IOControl` interface.

Parameters:
  `conn` - HTTP connection that can accommodate a new portion of the outgoing response content.
  `encoder` - The content encoder to use to write content.
See Also:
  `NHttpServerConnection`, `ContentEncoder`, `IOControl`

#### exception

    void exception(NHttpServerConnection conn,
                 IOException ex)

Deprecated.
Triggered when an I/O error occurs while reading from or writing to the underlying channel.

Parameters:
  `conn` - HTTP connection that caused an I/O error
  `ex` - I/O exception

#### exception

    void exception(NHttpServerConnection conn,
                 HttpException ex)

Deprecated.
Triggered when an HTTP protocol violation occurs while receiving an HTTP request.

Parameters:
  `conn` - HTTP connection that caused an HTTP protocol violation
  `ex` - HTTP protocol violation exception

#### timeout

    void timeout(NHttpServerConnection conn)

Deprecated.
Triggered when no input is detected on this connection over the maximum period of inactivity.

Parameters:
  `conn` - HTTP connection that caused timeout condition.

#### closed

    void closed(NHttpServerConnection conn)

Deprecated.
Triggered when the connection is closed.

Parameters:
  `conn` - closed HTTP connection.